> For the complete documentation index, see [llms.txt](https://docs.flatredball.com/flatredball/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flatredball.com/flatredball/tiled-plugin/flatredball-tilegraphics-mapdrawablebatch/removequads.md).

# RemoveQuads

### Introduction

RemoveQuads can be used to remove quads from the MapDrawableBatch by index. This method is useful in situations where you want to remove tiles from the MapDrawableBatch at runtime, such as when creating Entities from the contents of a tile map.

### Code Example

The following shows how to remove the first three tiles from the MapDrawableBatch:

```
List<int> toRemove = new List<int>();
toRemove.Add(0);
toRemove.Add(1);
toRemove.Add(2);
// assuming MyLevel is a valid LayeredTileMap:
MyLevel.MapLayers[0].RemoveQuads(toRemove);
```

For more information on LayeredTileMap, see the [LayeredTileMap page](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php).

### Code Example - Removing Quads With the Cursor

Often the internal quad ordering is unknown. Therefore, the MapDrawableBatch class provides a GetQuadIndex method to convert world X and Y to an index. If no tile is located at the index, a value of null is returned. The following code could be used to remove quads when the user clicks a mouse:

```
var cursor = GuiManager.Cursor;
if(cursor.PrimaryPush)
{
  var quadIndex = MapLayer.GetQuadIndex(cursor.WorldX, cursor.WorldY);

  if(quadIndex != null)
  {
    // RemoveQuads takes an IEnumerable so that multiple quads can be removed at once
    List quads = new List(){quadIndex.Value};
    MapLayer.RemoveQuads(quads);
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.flatredball.com/flatredball/tiled-plugin/flatredball-tilegraphics-mapdrawablebatch/removequads.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
